local ChatFrame_AddMessageEventFilter, GetCoinTextureString, InterfaceOptionsFrame_OpenToCategory, PVEFrame_ShowFrame, ReloadUI, SlashCmdList, idTweaks, idTweaksModule, idTweaksOptions, Option, ToggleOption, Chat
do
  local _obj_0 = _G
  ChatFrame_AddMessageEventFilter, GetCoinTextureString, InterfaceOptionsFrame_OpenToCategory, PVEFrame_ShowFrame, ReloadUI, SlashCmdList, idTweaks, idTweaksModule, idTweaksOptions = _obj_0.ChatFrame_AddMessageEventFilter, _obj_0.GetCoinTextureString, _obj_0.InterfaceOptionsFrame_OpenToCategory, _obj_0.PVEFrame_ShowFrame, _obj_0.ReloadUI, _obj_0.SlashCmdList, _obj_0.idTweaks, _obj_0.idTweaksModule, _obj_0.idTweaksOptions
end
do
  local _obj_0 = idTweaksOptions
  Option, ToggleOption = _obj_0.Option, _obj_0.ToggleOption
end
do
  local _class_0
  local _parent_0 = idTweaksModule
  local _base_0 = {
    set_options = function(self)
      _class_0.__parent.__base.set_options(self)
      self.options:add_option(Option(self, "slash_commands", "Slash Commands", "Customize the Slash Commands", { }, {
        addon = ToggleOption(self, "addon", "/idtweaks (/idt)", "Open the idTweaks Options with /idtweaks and /idt"),
        reload = ToggleOption(self, "reload", "/reload (/rl)", "Reload the UI with /reload and /rl"),
        lfg = ToggleOption(self, "lfg", "/lfg", "Open the Group Finder with /lfg")
      }))
      return self.options:add_option(Option(self, "message_style", "Message Style", "Customize the chat message styles", { }, {
        enabled = ToggleOption(self, "enabled", "Enabled", "Change the style of your chat messages to a minimal format")
      }))
    end,
    check = function(self)
      self:slash_commands_check()
      return self:message_style_check()
    end,
    enable = function(self)
      return self:check()
    end,
    disable = function(self)
      self:slash_commands_disable()
      return self:message_style_disable()
    end,
    slash_commands_check = function(self)
      if self.db.slash_commands.addon then
        SlashCmdList["IDTWEAKS_ADDON"] = function(msg)
          self.ace_module:Print("Opening options")
          InterfaceOptionsFrame_OpenToCategory("idTweaks")
          InterfaceOptionsFrame_OpenToCategory("idTweaks")
          return InterfaceOptionsFrame_OpenToCategory("Automation")
        end
        _G.SLASH_IDTWEAKS_ADDON1 = "/idt"
        _G.SLASH_IDTWEAKS_ADDON2 = "/idtweaks"
      else
        _G.SlashCmdList["IDTWEAKS_ADDON"] = nil
        _G.SLASH_IDTWEAKS_ADDON1 = nil
        _G.SLASH_IDTWEAKS_ADDON2 = nil
      end
      if self.db.slash_commands.reload then
        _G.SlashCmdList["IDTWEAKS_RELOAD"] = ReloadUI
        _G.SLASH_IDTWEAKS_RELOAD1 = "/rl"
        _G.SLASH_IDTWEAKS_RELOAD2 = "/reload"
      else
        _G.SlashCmdList["IDTWEAKS_RELOAD"] = nil
        _G.SLASH_IDTWEAKS_RELOAD1 = nil
        _G.SLASH_IDTWEAKS_RELOAD2 = nil
      end
      if self.db.slash_commands.lfg then
        _G.SlashCmdList["IDTWEAKS_LFG"] = function()
          return PVEFrame_ShowFrame("GroupFinderFrame")
        end
        _G.SLASH_IDTWEAKS_LFG1 = "/lfg"
      else
        _G.SlashCmdList["IDTWEAKS_LFG"] = nil
        _G.SLASH_IDTWEAKS_LFG1 = nil
      end
    end,
    message_style = {
      formatters = {
        money = function(message)
          local gold = message:match("(%d+) Gold")
          local silver = message:match("(%d+) Silver")
          local copper = message:match("(%d+) Copper")
          if gold then
            gold = string.format("%02d", gold)
          end
          if silver then
            silver = string.format("%02d", silver)
          end
          if copper then
            copper = string.format("%02d", copper)
          end
          local total = ""
          if gold then
            total = total .. gold
          end
          if silver then
            total = total .. silver
          end
          if copper then
            total = total .. copper
          end
          return "+ " .. tostring(GetCoinTextureString(total))
        end
      },
      filters = {
        CHAT_MSG_AFK = { },
        CHAT_MSG_COMBAT_FACTION_CHANGE = {
          ["Reputation with (.+) increased by (.+)."] = "+ %2 rep (%1)"
        },
        CHAT_MSG_COMBAT_HONOR_GAIN = { },
        CHAT_MSG_COMBAT_MISC_INFO = { },
        CHAT_MSG_CURRENCY = {
          ["You receive currency: (.+)"] = function(message)
            return Chat.message_style.formatters.money(message)
          end
        },
        CHAT_MSG_DND = { },
        CHAT_MSG_GUILD_ACHIEVEMENT = {
          ["%%s has earned the achievement (.+)!"] = "\124cff00ff00g %1 %%s\124h"
        },
        CHAT_MSG_IGNORED = { },
        CHAT_MSG_LOOT = {
          ["You receive item: (.+)"] = "+ %1",
          ["You receive loot: (.+)"] = "+ %1",
          ["Received item: (.+)"] = "+ %1"
        },
        CHAT_MSG_MONEY = {
          ["Received (.+) Gold, (.+) Silver, (.+) Copper"] = function(message)
            return Chat.message_style.formatters.money(message)
          end,
          ["Received (.+) Silver, (.+) Copper"] = function(message)
            return Chat.message_style.formatters.money(message)
          end,
          ["Received (.+) Silver"] = function(message)
            return Chat.message_style.formatters.money(message)
          end,
          ["Received (.+) Copper"] = function(message)
            return Chat.message_style.formatters.money(message)
          end,
          ["You loot (.+) Gold, (.+) Silver, (.+) Copper"] = function(message)
            return Chat.message_style.formatters.money(message)
          end,
          ["You loot (.+) Silver, (.+) Copper"] = function(message)
            return Chat.message_style.formatters.money(message)
          end,
          ["You loot (.+) Silver"] = function(message)
            return Chat.message_style.formatters.money(message)
          end,
          ["You loot (.+) Copper"] = function(message)
            return Chat.message_style.formatters.money(message)
          end
        },
        CHAT_MSG_SKILL = {
          ["Your skill in (.+) has increased to (.+)."] = "+ %2 (%1)"
        },
        CHAT_MSG_SYSTEM = {
          ["Received (.+) Silver"] = "+ %1 s",
          ["Received (.+) of item: (.+)."] = "+ %2x%1",
          ["(.+) completed."] = "- quest (%1)",
          ["Quest accepted: (.+)"] = "+ quest (%1)",
          ["Received item: (.+)%."] = "+ %1",
          ["Experience gained: (.+)."] = "+ %1 xp",
          ["(.+) has come online."] = "+ %1",
          ["(.+) has gone offline."] = "- %1",
          ["You are now Busy: in combat"] = "+ Combat",
          ["You are no longer marked Busy."] = "- Combat",
          ["Discovered (.+): (.+) experience gained"] = "+ %2 xp (%1)",
          ["Quest Accepted (.+)"] = "+ quest (%1)",
          ["You are now Away: AFK"] = "+ AFK",
          ["You are no longer Away."] = "- AFK",
          ["You are no longer rested."] = "- Rested",
          ["You don\"t meet the requirements for that quest."] = "! quest (Requirements not met)"
        },
        CHAT_MSG_TARGETICONS = { },
        CHAT_MSG_TRADESKILLS = { }
      }
    },
    message_style_check = function(self)
      if self.db.message_style.enabled then
        return self:message_style_enable()
      else
        return self:message_style_disable()
      end
    end,
    message_style_enable = function(self)
      for event, event_filters in pairs(self.message_style.filters) do
        ChatFrame_AddMessageEventFilter(event, function(frame, ev, message, ...)
          for k, v in pairs(event_filters) do
            if message:match(k) then
              if (type(v)) == "function" then
                message = v(message)
              else
                message = message:gsub(k, v)
              end
              return nil, message, ...
            end
          end
          return nil, message, ...
        end)
      end
    end,
    message_style_disable = function(self) end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  _class_0 = setmetatable({
    __init = function(self, addon)
      return _class_0.__parent.__init(self, addon, "Chat", "AceConsole-3.0", "AceEvent-3.0", "AceHook-3.0")
    end,
    __base = _base_0,
    __name = "Chat",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        local parent = rawget(cls, "__parent")
        if parent then
          return parent[name]
        end
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Chat = _class_0
end
return idTweaks:add_module(Chat(idTweaks))
